///home/berryj/link/bin/genMethods "-g" "-t" "MSet<int>" "-h" "Set" "-r" "MSet<MSet<int> >" "-I" "LINK/basic/Set.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/Set.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef MSet<int> _MSet_int_;
typedef Set<MSet<int> > _Set_MSet_int__;
static Set<MSet<int> > s__Set_MSet_int__;

#define _Set_MSet_int__DATA(x) ((Set<MSet<int> >*) (EXTDATA(x)))
#define _Set_MSet_int__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Set<MSet<int> > >::type))
#define _Set_MSet_int__ISNT_DATA(x) (!_Set_MSet_int__IS_DATA(x))

#define _Set_MSet_int__CXX_DATA(x) (*(Set<MSet<int> >*) (EXTDATA(VAL(x))))
#define _Set_MSet_int__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Set<MSet<int> > >::type))
#define _Set_MSet_int__CXX_ISNT_DATA(x) (!_Set_MSet_int__CXX_IS_DATA(x))


PRIMITIVE STk_init__Set_MSet_int__()
{
	Wrapper<_Set_MSet_int__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Set_MSet_int__>::name, 
			Wrapper<MSet<MSet<int> > >::name,
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_MSet_int_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_MSet_int_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_MSet_int_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Set_MSet_int__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Set_MSet_int__Methods(void);

PRIMITIVE STk_init_methods__Set_MSet_int__()
{
	genExtra_Set_MSet_int__Methods();
	return UNDEFINED;
}
